<template>
  <b-container fluid>

    <b-card :header="caption">
      <div slot="header">
        Отчеты
        <div class="card-header-actions">
          <button class="btn btn-primary btn-sm" @click="openAddingModal" :disabled="isDisabled()">
            <i class="icon-plus"></i>
          </button>
        </div>
      </div>
      <form>
        <b-form-group>
          <label>Напишите год:</label>
          <b-form-input name="year" v-model="selected.year"></b-form-input>
        </b-form-group>
        <b-form-group>
          <label>Выберите месяц:</label>
          <b-form-select :options="mmonths" name="month" v-model="selected.month"></b-form-select>
        </b-form-group>
        <b-button @click.prevent="getTables()" class="mr-1 tableActionbtn">
          Показать
        </b-button>

      </form>
      <br />
      <div v-if="isSelected">
        <download-excel
          class   = "btn btn-success pull-right mb-sm-2"
          :data   = "items"
          :fields = "jsonFields1"
          name    = "filename.xls">

          Скачать Excel

        </download-excel>

        <b-table :hover="hover" :striped="striped" :bordered="bordered" :small="small" responsive :items="items" :fields="fields2" :current-page="currentPage" :per-page="perPage">
          <template slot="action" slot-scope="data">
            <b-button title="Подробнее" @click="toCityDetailsPage(data.item)" class="mr-1 tableActionbtn">
              <i class="icon-eye"></i>
            </b-button>
          </template>
        </b-table>
        <nav>
          <b-pagination :total-rows="getRowCount(items)" :per-page="perPage" v-model="currentPage" prev-text="Предыдущая" next-text="Следующая" hide-goto-end-buttons/>
        </nav>

        <download-excel
          class   = "btn btn-success pull-right mb-sm-2"
          :data   = "outgoes"
          :fields = "jsonFields2"
          name    = "filename.xls">

          Скачать Excel

        </download-excel>

        <nav>
          <b-form-input v-model="filter2" placeholder="Поиск..." />
        </nav>
        <b-table :hover="hover" :striped="striped" :bordered="bordered" :small="small" @filtered="onFiltered2" :filter="filter2" responsive :items="outgoes" :fields="fields3" :current-page="currentPage2" :per-page="perPage2">
          <template slot="cause" slot-scope="data">
            {{ data.item.cause == 'present' ? 'Представитель' : data.item.cause }}
          </template>
          <template slot="action" slot-scope="data">
            <b-button title="Подробнее" @click="toDetailsPage(data.item)" class="mr-1 tableActionbtn">
              <i class="icon-eye"></i>
            </b-button>
          </template>
        </b-table>
        <nav>
          <b-pagination :total-rows="rowCount" :per-page="perPage2" v-model="currentPage2" prev-text="Предыдущая" next-text="Следующая" hide-goto-end-buttons/>
        </nav>
      </div>
    </b-card>

    <b-modal id="addingModal" @hide="resetModal" title="Добавление отчета" centered @ok="adding" ok-only>
      <b-container fluid>
        <b-form-group>
          <label>Сумма *</label>
          <b-form-input type="text" name="summ" placeholder="Сумма" v-model="addedModal.summ" v-validate="'required'"></b-form-input>
          <span v-show="errors.has('summ')" class="text-danger">{{ errors.first('summ') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Коментарий *</label>
          <b-form-input type="text" name="comment" placeholder="Коментарий" v-model="addedModal.comment" v-validate="'required'"></b-form-input>
          <span v-show="errors.has('comment')" class="text-danger">{{ errors.first('comment') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Назначение *</label>
          <b-form-select type="text" name="cause" placeholder="Назначение" v-model="addedModal.cause" :options="causes" v-validate="'required'"></b-form-select>
          <span v-show="errors.has('cause')" class="text-danger">{{ errors.first('cause') }}</span>
        </b-form-group>
        <b-form-group v-if="addedModal.cause == 'present'">
          <label>Представитель *</label>
          <b-form-select type="text" name="present" v-model="addedModal.present" :options="presents" v-validate="'required'"></b-form-select>
          <span v-show="errors.has('present')" class="text-danger">{{ errors.first('present') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Детальное назначение</label>
          <b-form-input type="text" name="addedModal.detailedCause" placeholder="Детальное назначение" v-model="addedModal.detailedCause"></b-form-input>
        </b-form-group>
        <b-form-group>
          <label>Сотрудник *</label>
          <b-form-select :options="employees" v-model="addedModal.employee" name="employee" v-validate="'required'"></b-form-select>
          <span v-show="errors.has('employee')" class="text-danger">{{ errors.first('employee') }}</span>
        </b-form-group>
        <b-form-group>
          <label>Дата *</label>
          <datepicker :language="ru" v-model="addedModal.date" name="date" v-validate="'required'"></datepicker>
          <span v-show="errors.has('date')" class="text-danger">{{ errors.first('date') }}</span>
          <!-- <b-form-input type="text" name="addedUser.birthday" placeholder="Дата рождения" v-model="addedUser.birthday"></b-form-input> -->
        </b-form-group>

        <b-btn class="mt-3" variant="primary" block @click="adding">Добавить</b-btn>
      </b-container>
      <div slot="modal-footer" class="w-100">
      </div>
    </b-modal>
  </b-container>
</template>

<script>
import { ru } from 'vuejs-datepicker/dist/locale'
import Api from '@/services/Api'
import Datepicker from 'vuejs-datepicker'

const MONTHS = [
  'январь',
  'февраль',
  'марта',
  'апрель',
  'май',
  'июнь',
  'июль',
  'август',
  'сентябрь',
  'октябрь',
  'ноябрь',
  'декабрь'
]

export default {
  name: 'Reports',
  components: {
    Datepicker
  },
  props: {
    caption: {
      type: String,
      default: 'Отчеты'
    },
    hover: {
      type: Boolean,
      default: true
    },
    striped: {
      type: Boolean,
      default: true
    },
    bordered: {
      type: Boolean,
      default: true
    },
    small: {
      type: Boolean,
      default: true
    }
  },
  data: () => {
    return {
      userLevel: localStorage.getItem('level'),
      jsonFields1: {
        'Дата' : 'date',
        'Приход' : 'totalSumm',
        'Расход' : 'totalOutgoes',
        'Прибыль' : 'profit'
      },
      jsonFields2: {
        'Статья' : 'cause',
        'Сумма' : 'summ',
      },
      causes: [],
      presents: [],
      ru: ru,
      items: [],
      employees: [],
      outgoes: [],
      isSelected: false,
      totalSumm: '',
      years: [
        { value: 2016, text: '2016' },
        { value: 2016, text: '2017'},
        { value: 2016, text: '2018'}
      ],
      mmonths: [
        { value: 1, text: 'январь' },
        { value: 2, text: 'февраль' },
        { value: 3, text: 'марта' },
        { value: 4, text: 'апрель' },
        { value: 5, text: 'май' },
        { value: 6, text: 'июнь' },
        { value: 7, text: 'июль' },
        { value: 8, text: 'август' },
        { value: 9, text: 'сентябрь' },
        { value: 10, text: 'октябрь' },
        { value: 11, text: 'ноябрь' },
        { value: 12, text: 'декабрь' }
      ],
      selected: {
        year: '',
        month: ''
      },
      month: '',
      year: '',
      fields1: [
        { key: 'number', sortable: true, label: 'Номер' },
        { key: 'article', sortable: true, label: 'Статья' },
        { key: 'date', sortable: true, label: 'Дата' },
      ],
      fields2: [
        { key: 'date', sortable: true, label: 'Дата' },
        { key: 'totalSumm', sortable: true, label: 'Приход' },
        { key: 'totalOutgoes', sortable: true, label: 'Расход' },
        { key: 'profit', sortable: true, label: 'Прибыль' },
        { key: 'action', sortable: true, label: 'Действия' },
      ],
      fields3: [
        { key: 'cause', sortable: true, label: 'Статья' },
        { key: 'summ', sortable: true, label: 'Сумма' },
        { key: 'action', sortable: true, label: 'Действия' },
      ],
      addedModal: {
        summ: '',
        comment: '',
        cause: '',
        present: '',
        detailedCause: '',
        employee: '',
        date: ''
      },
      currentPage: 1,
      perPage: 10,
      totalRows: 0,
      filter: null,
      currentPage2: 1,
      perPage2: 10,
      totalRows2: 0,
      filter2: null,
      rowCount: 1,
      reportsDetailedByCity: []
    }
  },
  beforeMount () {
    this.getPresents()
    this.getArticles()
    this.getEmployees()
    this.getReports().then(() => {
      if (this.$route.query.year && this.$route.query.month) {
        this.selected.year = this.$route.query.year
        this.selected.month = this.$route.query.month
        this.getReports().then(() => {
          this.isSelected = true
          this.getOutgoes()
        })

      } else {
        this.isSelected = false
        this.selected.year = ''
        this.selected.month = ''
      }
    })
  },
  computed: {
    disabled () {
      if (this.addedModal.summ.length > 0 && this.addedModal.comment.length > 0 && this.addedModal.cause.length > 0 &&
        this.addedModal.detailedCause.length > 0 && this.addedModal.date) {
        return false
      } else {
        return true
      }
    }
  },
  computed: {
    filterByCity() {

    }
  },
  methods: {
    isDisabled() {
      return this.userLevel === "2"
    },
    getArticles () {
      Api().get('getcauses').then(response => {
        this.causes = response.data.causes.map(item => {
          return { value: item.name, text: item.name }
        })
        this.causes.push({value: 'present', text: 'Представителю'})
      })
    },
    getPresents () {
      Api().post('getByParameters', {type: 'present'}).then(response => {
        this.presents = response.data.map(item => {
          return { value: item._id, text: item.lastName + ' ' + item.name }
        })
      })
    },
    getTables () {
      this.$router.push({ path: 'reports', query: { year: this.selected.year, month: this.selected.month }})
      this.isSelected = true
      this.getReports().then(() => {
        this.getOutgoes()
      })

    },
    getReports () {
      return Api().post('getreports', { year: this.selected.year, month: this.selected.month }).then(response => {
        this.reportsDetailedByCity = response.data.reportsDetailed
        //I did it because of problems in back with date
        if (response.data.result.length > 1) {
          var data = response.data.result
          var totalSumm = (data[0].totalSumm || 0 ) + (data[1].totalSumm || 0)
          this.totalSumm = totalSumm
          var totalOutgoes = (data[0].totalOutgoes || 0) + (data[1].totalOutgoes || 0)
          this.items = [{
            date: data[1]._id.year + ', ' + MONTHS[data[1]._id.month - 1],
            totalSumm: totalSumm || 0,
            totalOutgoes: totalOutgoes || 0,
            profit: totalSumm - totalOutgoes
          }]
        } else {
          this.items = response.data.result.map(item => {
            this.totalSumm = item.totalSumm
            return {
              date: item._id.year + ', ' + MONTHS[item._id.month - 1],
              totalSumm: item.totalSumm || 0,
              totalOutgoes: item.totalOutgoes || 0,
              profit: (item.totalSumm || 0) - (item.totalOutgoes || 0)
            }
          })
        }

      })
    },
    getOutgoes () {
      Api().post('getoutgoesShort', {year: this.selected.year, month: this.selected.month}).then(response => {
        this.outgoes = []
        this.outgoes = response.data.map(item => {
          return {
            cause: item._id.cause,
            summ: item.totalOutgoes
          }
        })
        if (response.data.length > 0) {
          this.outgoes.unshift({cause: 'Перевозка', summ: this.totalSumm || 0})
        }

      })
    },
    getEmployees () {
      Api().get('getEmployees').then(response => {
        this.employees = response.data.users.map(item => {
          return { value: item._id, text: item.name + ' ' + item.lastName }
        })
      })
    },
    adding () {
      this.$validator.validateAll()
      if (this.validateAdding()) {
        if (this.addedModal.present.length <= 0) {
          delete this.addedModal.present
        }
        Api().post('addOutgoes', this.addedModal).then(response => {
          this.resetModal()
          window.location.reload()
        })
      }
    },
    validateAdding () {
      if (this.addedModal.summ.length > 0 && this.addedModal.comment.length > 0 && this.addedModal.cause.length > 0
        && this.addedModal.date) {
          if (this.addedModal.cause == 'present' && this.addedModal.present.length == 0) {
            return false
          } else {
            return true
          }
      } else {
        return false
      }
    },
    info (_item) {
      this.modalInfo = _item
      this.$root.$emit('bv::show::modal', 'modalInfo')
    },
    onFiltered2 (filteredItems) {
      this.rowCount = filteredItems.length
      this.currentPage2 = 1
    },
    getRowCount (items) {
      return items.length
    },
    resetModal () {
      this.addedModal.summ = ''
      this.addedModal.comment = ''
      this.addedModal.cause = ''
      this.addedModal.detailedCause = ''
      this.addedModal.employee = ''
      this.addedModal.date = ''
      this.errors.clear()
    },
    openAddingModal () {
      this.$root.$emit('bv::show::modal', 'addingModal')
    },
    toDetailsPage (item) {
      //item.cause = item.cause == 'Представитель' ? 'present' :
      item.date = {
        year: this.selected.year,
        month: this.selected.month
      }
      this.$router.push({
        name: 'ReportDetails',
        query: {
          year: this.selected.year,
          month: this.selected.month,
          cause: item.cause
        }
      })
    },



    toCityDetailsPage (item) {
      //item.cause = item.cause == 'Представитель' ? 'present' :
      item.date = {
        year: this.selected.year,
        month: this.selected.month
      }
      this.$router.push({
        name: 'ReportDetailCity',
        params: {
          props: {
            reportsDetailedByCity: this.reportsDetailedByCity
          }
        }
      })
    },



  }
}
</script>
